#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}

int main(int argc, char *argv[])
{
  int n;
  int i;
  int ch;
  int len;
  int pf[2],fp[2];
  char filename[100];
  char buf[1024];


  if (argc < 2) {
    printf("Uso: %s <nome file>\n", argv[0]);
    exit(0);
  }
  
  pipe(pf);
  pipe(fp);
  
  if ( (ch = fork()) < 0 ) sys_err("errore nella fork");

  if (ch == 0) {
    char fname[100];
    close(pf[1]);
    close(fp[0]);
    
    if (read(pf[0], &len, sizeof(int)) <= 0) 
      sys_err("errore nella read");
    
    for (i = 0; i < len; i++) {
      if (read(pf[0], &(fname[i]), 1) < 0)
	sys_err("errore nella read");
    }
    fname[len] = 0;

    dup2(fp[1],1);
    execlp("cat", "cat", fname, (char *)0); 
  }
  
  close(pf[0]);
  close(fp[1]);

  strcpy(filename, argv[1]);

  len = strlen(filename);
  
  if (write(pf[1], &len, sizeof(int)) < 0)
    sys_err("errore nella write");
  
  if (write(pf[1], filename, len) < 0)
    sys_err("errore nella write");
  
  while ((n = read(fp[0], buf, sizeof(buf))) != 0) 
    write(STDOUT_FILENO, buf, n);
  
  exit(0);
}




