#include <sys/types.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}

int main(void)
{
  int i;
  pid_t ch, parent;
  int pf[2],fp[2];
  int dato;
  
  if (pipe(pf) < 0) sys_err("errore nella pipe");
  if (pipe(fp) < 0) sys_err("errore nella pipe");

  if ( (ch = fork()) < 0) sys_err("fork error");
  
  if (ch == 0) {
    close(pf[1]);
    close(fp[0]);
    for(;;) {
      if (read(pf[0], &dato, sizeof(int)) < 0)
	sys_err("errore nella read");
      printf("Sono il figlio\n");
      if (write(fp[1], &dato, sizeof(int)) < 0) 
	sys_err("errore nella write");
    }
  }

  close(pf[0]);
  close(fp[1]);
  for (i=0; i<10; i++) {
    printf("Sono il padre\n");
    if (write(pf[1], &dato, sizeof(int)) < 0)
      sys_err("errore nella write");
    if (read(fp[0], &dato, sizeof(int)) < 0)
      sys_err("errore nella read");
  }

  kill(ch, SIGTERM);
  wait(0);
  exit(0);
}
