#include "util.h"
#include <malloc.h>
#include <sys/wait.h>

void figlio(double a, double b)
{
  double ris;
  char fn[100];
  FILE *f;

  printf("Il figlio %d ha cominciato\n", getpid());
  ris = a * b;
  sprintf(fn, "ris%d", getpid());
  if ((f = fopen(fn,"w"))==0) sys_err("Errore nella creazione del file");
  fprintf(f, "%lf", ris);
  fclose(f);
  printf("Il figlio %d ha finito\n", getpid());
  exit(0);
}

int main(int argc, char *argv[])
{
  FILE *file, *f;
  char fn[100];
  int i;
  double sum, r;
  double *v1,*v2;
  int n;
  int ch;

  if (argc < 3) {
    printf("Uso: %s n filename\n", argv[0]);
    printf("n        : numero di elementi dei vettore\n");
    printf("filename : file contenente i due vettori\n");
    exit(0);
  }

  n = atoi(argv[1]);
  
  if ((file = fopen(argv[2], "r")) == NULL) 
    sys_err("Non posso aprire il file");
  
  v1 = malloc(n * sizeof(double));
  v2 = malloc(n * sizeof(double));

  leggi_vettore(file, v1, n);
  leggi_vettore(file, v2, n);

  fclose(file);

  sum = 0;
  for(i = 0; i < n; i++) {
    if (fork() == 0) {
      figlio(v1[i],v2[i]);
    }
    else printf("creato il figlio %d\n",i);
  }

  for (i = 0; i < n; i++) {
    printf("Sto aspettando...\n");
    ch = wait(0);
    sprintf(fn, "ris%d", ch);
    f = fopen(fn,"r");
    fscanf(f, "%lf", &r);
    sum += r;
    fclose(f);
    printf("Letto il risultato di %d\n", ch);
    remove(fn);
  }

  printf("il prodotto vettoriale e': %lf\n", sum);
}



