#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <utime.h>

int main(int argc, char *argv[])
{

  int i;
  struct stat     statbuf;
  struct utimbuf timebuf;

  if (argc < 2) {
    printf("Uso: %s file\n", argv[0]);
    exit(0);
  }

  if (lstat(argv[1], &statbuf) < 0) {
      perror("lstat error");
      exit(-1);
  }

  if (open(argv[1], O_RDWR | O_TRUNC) < 0) {
    perror("open error");
    exit(-1);
  }
  
  timebuf.actime  = statbuf.st_atime;
  timebuf.modtime = statbuf.st_mtime;
  if (utime(argv[1], &timebuf) < 0) {
    perror("utime error");
    exit(-1);
  }
}
