#include <sys/types.h>
#include <signal.h>
#include <stdio.h>

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}

int main(void)
{
  int c;
  int a,b,sum;
  pid_t ch;
  int pf[2], fp[2];

  if (pipe(pf) < 0) sys_err("pipe error");
  if (pipe(fp) < 0) sys_err("pipe error");

  if ( (ch = fork()) < 0) sys_err("fork error");
  
  if (ch == 0) {
    close(pf[1]);
    close(fp[0]);
    dup2(pf[0],0);
    dup2(fp[1],1);
    execlp("./sum", "sum", (char *)0);
  }

  close(pf[0]);
  close(fp[1]);
  for(;;) {
    printf("Inserisci a:");
    scanf("%d", &a);
    printf("Inserisci b:");
    scanf("%d", &b);
    if (write(pf[1], &a, sizeof(int)) < 0) sys_err("write error");
    if (write(pf[1], &b, sizeof(int)) < 0) sys_err("write error");
    if (read(fp[0], &sum, sizeof(int)) < 0) sys_err("read error");
    printf("La somma e' : %d\n", sum);
    printf("Ancora ? (s/n) ");
    c = getchar();
    while (c != 's' && c != 'n') c = getchar();
    if (c == 'n') {
      kill(ch, SIGTERM);
      wait(0);
      exit(0);
    }
  }
}

