#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}

#define FILE_MODE (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)

int main(void)
{
  int i;
  pid_t ch, parent;
  int fifo_padre, fifo_figlio;
  int dato;
  
  if (mkfifo("fifo_padre", FILE_MODE) < 0) {
    if (errno != EEXIST) 
      sys_err("errore nella fifo");
  }

  if (mkfifo("fifo_figlio", FILE_MODE) < 0) {
    if (errno != EEXIST) 
      sys_err("errore nella fifo");
  }

  if ( (ch = fork()) < 0) sys_err("fork error");
  
  if (ch == 0) {
    fifo_padre = open("fifo_padre", O_WRONLY);
    fifo_figlio = open("fifo_figlio", O_RDONLY);

    for(;;) {
      if (read(fifo_figlio, &dato, sizeof(int)) < 0)
	sys_err("errore nella read");
      printf("Sono il figlio\n");
      if (write(fifo_padre, &dato, sizeof(int)) < 0) 
	sys_err("errore nella write");
    }
  }

  fifo_padre = open("fifo_padre", O_RDONLY);
  fifo_figlio = open("fifo_figlio", O_WRONLY);

  for (i=0; i<10; i++) {
    printf("Sono il padre\n");
    if (write(fifo_figlio, &dato, sizeof(int)) < 0)
      sys_err("errore nella write");
    if (read(fifo_padre, &dato, sizeof(int)) < 0)
      sys_err("errore nella read");
  }

  kill(ch, SIGTERM);
  wait(0);
  exit(0);
}

