#include <sys/types.h>
#include <signal.h>
#include <stdio.h>

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}


int flag = 0;

void handler(int no)
{
  if (no != SIGUSR1) sys_err("Segnale sbagliato!");

  flag = 1;
}

int main(void)
{
  int i;
  pid_t ch, parent;
  struct sigaction nuova,vecchia;

  nuova.sa_handler = handler;
  sigemptyset(&nuova.sa_mask);
  nuova.sa_flags = 0;

  sigaction(SIGUSR1,&nuova,&vecchia);

  if ( (ch = fork()) < 0) sys_err("fork error");
  
  if (ch == 0) {
    parent = getppid();
    for(;;) {
      while(flag == 0);
      printf("Sono il figlio\n");
      flag = 0;
      kill(parent, SIGUSR1);
    }
  }
  
  for (i=0; i<10; i++) {
    flag = 0;
    printf("Sono il padre\n");
    kill(ch, SIGUSR1);
    while(flag==0);
  }

  kill(ch, SIGTERM);
  wait(0);
  exit(0);
}
