#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MAXBUF_SIZE       100

void sys_err(char *s)
{
  perror(s);
  exit(-1);
}


int main()
{
  FILE *file;
  char buf[MAXBUF_SIZE];
  pid_t ch;
  int fp[2];
  int n, len;

  if (pipe(fp) < 0) sys_err("Errore nell'apertura della pipe");

  if ((ch = fork()) < 0) sys_err("Errore nella fork");

  if (ch == 0) {
    close(fp[0]);
    if ((file = popen("ls -1", "r")) <= 0) 
      sys_err("errore nella popen");

    while (fscanf(file, "%s", buf) != EOF) { 
      len = strlen(buf);
      if (write(fp[1], &len, sizeof(len)) < 0) 
	sys_err("errore nella write");
      if (write(fp[1], buf, len) < 0)
	sys_err("errore nella write");
    }
    close(fp[1]);
    pclose(file);
    exit(0);
  }
  
  close(fp[1]);
  
  while(1) {
    n = read(fp[0], &len, sizeof(int));
    if (n == 0) {
      close(fp[1]);
      wait(0);
      exit(0);
    }
    
    if ((n = read(fp[0], buf, len)) <= 0) sys_err("errore nella read!");

    buf[len] = 0;
    printf("%s\n", buf);
  }
  
}


